
{ LBL = 1 }

const
      STATUS   = $00;         {Register der GDP9366 Emulation}
      CMD      = $00;
      CTRL1    = $10;
      CTRL2    = $20;
      CSIZE    = $30;
      DELTAX   = $40;
      DELTAY   = $50;
      Xlsb     = $60;
      Ylsb     = $70;
      COLOR    = $80;
      SCROLL   = $90;
      RAM      = $a0;
      PAGESEL  = $b0;

      HSTADRLl = $D7;
      HSTADRLh = $D6;
      HSTADRHl = $D5;
      HSTADRHh = $D4;
      HSTCTRLl = $D3;
      HSTCTRLh = $D2;
      HSTDATAl = $D1;
      HSTDATAh = $D0;

      selpen   = 0;
      selera   = 1;
      down     = 2;
      up       = 3;
      clrscr   = 4;
      home     = 5;
      clrhome  = 6;
      clrall   = 7;
      bblock   = 10;
      lblock   = 11;
      cont     = 0;
      dot      = 1;
      dash     = 2;
      dotdash  = 4;
      hori     = 0;
      vert     = 8;
      norm     = 0;
      cursiv   = 4;

type
       zeile        = string[80];

function get_gdp(adr:byte) : integer;
begin
{ port[HSTADRHh] := $00;     }
{ port[HSTADRHl] := $20;     }
{ port[HSTADRLh] := hi(adr); }
{ port[HSTADRLl] := lo(adr); }
{ get_gdp :=  (port[HSTDATAh] shl 8)) or (port[HSTDATAl]; }
inline(
  $7D/              { ld  a,l          }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $DB/HSTDATAh/     { in  a,(HSTDATAh) }
  $67/              { ld  h,a          }
  $DB/HSTDATAl/     { in  a,(HSTDATAl) }
  $6F/              { ld  l,a          }
  $C9);             { ret              }
end;

procedure put_gdp(adr:byte;wert:integer);
begin
{ port[HSTADRHh] := $00;     }
{ port[HSTADRHl] := $20;     }
{ port[HSTADRLh] := hi(adr); }
{ port[HSTADRLl] := lo(adr); }
{ port[HSTDATAh] := hi(wert); }
{ port[HSTDATAl] := lo(wert); }
inline(
  $7D/              { ld  a,l          }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $21/wert+1/       { ld  hl,wert+1    }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAh/     { out (HSTDATAh),a }
  $2B/              { dec hl           }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAl);    { out (HSTDATAl),a }
end;

Procedure WaitGDP;
{Ueberprueft, ob der EF9366 bereit fuer einen neuen Befehl ist}
{Erst dann wird die Procedure verlassen}
Begin
{  Repeat until (get_gdp(STATUS) and $0400) <> 0; }
  inline(
  $AF/              {     xor a            }
  $D3/HSTADRLl/     {     out (HSTADRLl),a }
  $DB/HSTDATAh/     { lp: in  a,(HSTDATAh) }
  $E6/$04/          {     and 04h          }
  $DB/HSTDATAl/     {     in  a,(HSTDATAl) }
  $28/$F8);         {     jr  z,lp         }
End; {WaitGDP}

procedure waitsync;
{Ueberprueft, ob der EF9366 vertical blanking ausfuehrt}
{Erst dann wird die Procedure verlassen}
Begin
{  Repeat until (get_gdp(STATUS) and $0200) <> 0; }
  inline(
  $AF/              {     xor a            }
  $D3/HSTADRLl/     {     out (HSTADRLl),a }
  $DB/HSTDATAh/     { lp: in  a,(HSTDATAh) }
  $E6/$02/          {     and 02h          }
  $DB/HSTDATAl/     {     in  a,(HSTDATAl) }
  $28/$F8);         {     jr  z,lp         }
end;

procedure InitGDP;
begin
  port[HSTCTRLl] := 0;
  port[HSTCTRLh] := $20;    { Lower byte last }
  WaitGDP;
  put_gdp(PAGESEL,0);
  put_gdp(SCROLL,0);
  put_gdp(COLOR,$0f);
  put_gdp(CMD,$08);
  WaitGDP;
  put_gdp(CMD,clrall);
  WaitGDP;
  put_gdp(CMD,selpen);
  WaitGDP;
  put_gdp(CMD,down);
end;

procedure clrscreen;
begin
  waitgdp;
  put_gdp(CMD,clrhome);
end;

procedure textout (text:zeile);
var       i:byte;
begin;
  for i:=1 to length(text) do
  begin
    waitgdp;
    put_gdp(CMD,ord(text[i]));
  end;
end;

procedure moveto (x,y:integer);
begin;
{  waitgdp; }
{  put_gdp(Xlsb,x); }
{  put_gdp(Ylsb,y); }
  inline(
  $AF/              {     xor a            }
  $D3/HSTADRLl/     {     out (HSTADRLl),a }
  $DB/HSTDATAh/     { lp: in  a,(HSTDATAh) }
  $E6/$04/          {     and 04h          }
  $DB/HSTDATAl/     {     in  a,(HSTDATAl) }
  $28/$F8/          {     jr  z,lp         }
  $3e/Xlsb/         { ld  a,Xlsb       }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $21/x+1/          { ld  hl,x+1       }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAh/     { out (HSTDATAh),a }
  $2B/              { dec hl           }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAl/     { out (HSTDATAl),a }
  $3e/Ylsb/         { ld  a,Ylsb       }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $21/y+1/          { ld  hl,y+1       }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAh/     { out (HSTDATAh),a }
  $2B/              { dec hl           }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAl);    { out (HSTDATAl),a }
end;

procedure drawto (x2,y2:integer);
begin
{  waitgdp; }
{  put_gdp(DELTAX,x2-get_gdp(Xlsb)); }
{  put_gdp(DELTAX,y2-get_gdp(Ylsb)); }
{  put_gdp(CMD,17); }
  inline(
  $AF/              {     xor a            }
  $D3/HSTADRLl/     {     out (HSTADRLl),a }
  $DB/HSTDATAh/     { lp: in  a,(HSTDATAh) }
  $E6/$04/          {     and 04h          }
  $DB/HSTDATAl/     {     in  a,(HSTDATAl) }
  $28/$F8/          {     jr  z,lp         }
  $3E/Xlsb/         { ld  a,Xlsb       }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $DB/HSTDATAh/     { in  a,(HSTDATAh) }
  $57/              { ld  d,a          }
  $DB/HSTDATAl/     { in  a,(HSTDATAl) }
  $5F/              { ld  e,a          }
  $21/x2/           { ld  hl,x2        }
  $7E/              { ld  a,(hl)       }
  $23/              { inc hl           }
  $66/              { ld  h,(hl)       }
  $6F/              { ld  l,a          }
  $AF/              { xor a            }
  $ED/$52/          { sbc hl,de        }
  $3e/DELTAX/       { ld  a,DELTAX     }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $7C/              { ld  a,h          }
  $D3/HSTDATAh/     { out (HSTDATAh),a }
  $7D/              { ld  a,h          }
  $D3/HSTDATAl/     { out (HSTDATAl),a }
  $3E/Ylsb/         { ld  a,Ylsb       }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $DB/HSTDATAh/     { in  a,(HSTDATAh) }
  $57/              { ld  d,a          }
  $DB/HSTDATAl/     { in  a,(HSTDATAl) }
  $5F/              { ld  e,a          }
  $21/y2/           { ld  hl,y2        }
  $7E/              { ld  a,(hl)       }
  $23/              { inc hl           }
  $66/              { ld  h,(hl)       }
  $6F/              { ld  l,a          }
  $AF/              { xor a            }
  $ED/$52/          { sbc hl,de        }
  $3e/DELTAY/       { ld  a,DELTAY     }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $7C/              { ld  a,h          }
  $D3/HSTDATAh/     { out (HSTDATAh),a }
  $7D/              { ld  a,h          }
  $D3/HSTDATAl/     { out (HSTDATAl),a }
  $AF/              { xor a            }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $D3/HSTDATAh/     { out (HSTDATAh),a }
  $3E/$11/          { ld  a,17         }
  $D3/HSTDATAl);    { out (HSTDATAl),a }
end;

procedure plot (x,y:integer);
begin;
  moveto (x,y);
  drawto (x,y);
end;

procedure rechteck (x1,y1,x2,y2:integer);
begin
  moveto (x1,y1);
  drawto (x2,y1);
  drawto (x2,y2);
  drawto (x1,y2);
  drawto (x1,y1);
end;

procedure kreis (x0,y0,r:integer);
var        i,x,rq,y,u1,u2,u3,u4,v1,v2,v3,v4:integer;
(* Kreisalloritmus ohne SINUS und COSINUS. Arbeitet mit SQR, *)
(* also Phytagoreas, und 4-facher Spiegelung/Drehung. Sehr   *)
(* schnell. Nachteil: kann (in dieser Version) keine Kreis-  *)
(* segmente. 1.66 sorgt fr 'runde' Kreise. Optimierung	     *)
(* noch nicht ausgereitzt.	Volker.		 	     *)
begin
  rq := r*r;
  for i:=0 to trunc(r/2.828) do begin
    y:=i*2;
    x:=trunc(sqrt(rq-y*y));
    u1:=trunc(x0-x*1.66);
    u2:=trunc(x0+x*1.66);
    v1:=y0-y;
    v2:=y0+y;
    u3:=trunc(x0-y*1.66);
    u4:=trunc(x0+y*1.66);
    v3:=y0-x;
    v4:=y0+x;
    plot (u1,v1);
    plot (u1,v2);
    plot (u2,v1);
    plot (u2,v2);
    plot (u3,v3);
    plot (u3,v4);
    plot (u4,v3);
    plot (u4,v4);
  end;
end;

