
function get_gdp(adr:integer) : integer;
begin
{ port[HSTADRLl] := lo(adr); }
{ port[HSTADRLh] := hi(adr); }
{ port[HSTADRHl] := $20;     }
{ port[HSTADRHh] := $00;     }
inline(
  $7D/              { ld  a,l          }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $7C/              { ld  a,h          }
  $D3/HSTADRLh/     { out (HSTADRLh),a }
  $3E/$20/          { ld  a,020h       }
  $D3/HSTADRHl/     { out (HSTADRHl),a }
  $AF/              { xor a            }
  $D3/HSTADRHh/     { out (HSTADRHh),a }
{  get_gdp := (port[HSTDATAl] or (port[HSTDATAh] shl 8)); }
  $DB/HSTDATAl/     { in  a,(HSTDATAl) }
  $6F/              { ld  l,a          }
  $DB/HSTDATAh/     { in  a,(HSTDATAh) }
  $67/              { ld  h,a          }
  $C9);             { ret              }
end;

procedure put_gdp(adr,wert:integer);
begin
{ port[HSTADRLl] := lo(adr); }
{ port[HSTADRLh] := hi(adr); }
{ port[HSTADRHl] := $20;     }
{ port[HSTADRHh] := $00;     }
inline(
  $7D/              { ld  a,l          }
  $D3/HSTADRLl/     { out (HSTADRLl),a }
  $7C/              { ld  a,h          }
  $D3/HSTADRLh/     { out (HSTADRLh),a }
  $3E/$20/          { ld  a,020h       }
  $D3/HSTADRHl/     { out (HSTADRHl),a }
  $AF/              { xor a            }
  $D3/HSTADRHh/     { out (HSTADRHh),a }
{ port[HSTDATAl] := lo(wert); }
{ port[HSTDATAh] := hi(wert); }
  $21/wert/         { ld  hl,wert      }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAl/     { out (HSTDATAl),a }
  $23/              { inc hl           }
  $7E/              { ld  a,(hl)       }
  $D3/HSTDATAh);    { out (HSTDATAh),a }
end;

Function Pen      : Boolean; Forward;
Function Eraser   : Boolean; Forward;
Function Up       : Boolean; Forward;
Function Down     : Boolean; Forward;
Function OutRange : Boolean; Forward;

Procedure GDPready;
{Ueberprueft, ob der EF9366 bereit fuer einen neuen Befehl ist}
{Erst dann wird die Procedure verlassen}
Begin
{  Repeat until (get_gdp(STATUS) and $0400) <> 0; }
  inline(
  $AF/              {     xor a            }
  $D3/HSTADRLl/     {     out (HSTADRLl),a }
  $D3/HSTADRLh/     {     out (HSTADRLh),a }
  $3E/$20/          {     ld  a,020h       }
  $D3/HSTADRHl/     {     out (HSTADRHl),a }
  $AF/              {     xor a            }
  $D3/HSTADRHh/     {     ld  (HSTADRHh),a }
  $DB/HSTDATAl/     { lp: in  a,(HSTDATAl) }
  $DB/HSTDATAh/     {     in  a,(HSTDATAh) }
  $E6/$04/          {     and 04h          }
  $28/$F8);         {     jr  z,lp         }
End; {GDPready}

Procedure VBready;
{Ueberprueft, ob der EF9366 vertical blanking ausfuehrt}
{Erst dann wird die Procedure verlassen}
Begin
  Repeat until (get_gdp(STATUS) and $0200) = $0200;
End; {VBready}

Procedure SetColor(foreground,background:byte);
{Setzet neue Farben(Graustufen) fuer Vorder- und Hintergrund}
Begin
  GDPReady;
  put_gdp(COLOR,((background and 15) shl 4) or (foreground and 15));
  put_gdp(CMD,8);
End; {SetColor}

Procedure SelPen;
{Selektiert als Schreibstift Pen}
Begin;
  GDPready;
  put_gdp(CMD,0);
End; {SelPen}

Procedure SelEraser;
{Selektiert als Schreibstift Eraser}
Begin;
  GDPready;
  put_gdp(CMD,1);
End; {SelEraser}

Procedure SelUp;
{Schreibstift wird hochgesetzt}
Begin
  GDPready;
  put_gdp(CMD,3);
End; {SelUp}

Procedure SelDown;
{Schreibstift wird abgesetzt}
Begin
  GDPready;
  put_gdp(CMD,2);
End; {SelDown}

Procedure SelType(Art : Byte);
{Waehlt die Strichart der Vektoren aus, Art 0..3}
Begin;
  GDPready;
  put_gdp(CTRL2, (get_gdp(CTRL2) and 12) or Art);
End; {SelChar}

Procedure ClrGDP;
{Loescht die gewaehle Seite des GDP9366}
Begin
  GDPready;
  put_gdp(CMD,4);
End; {ClrGDP}

Procedure ClrXY;
{Setzt Register X und Y des EF9366 auf 0}
Begin
  GDPready;
  put_gdp(CMD,5);
End; {ClrXY}

Procedure ClrGDPXY;
{Loescht die gewaehle Seite des GDP9366}
{Setzt Register X und Y des EF9366 auf 0}
Begin
  GDPready;
  put_gdp(CMD,6);
End; {ClrGDPXY}

Procedure SelPage(WritePage,ReadPage : Byte);
{Schaltet die einzelnen Seiten der GDP9366 um}
{Keine Parameterueberpruefung}
Begin;
  GDPready;
  VBready;
  put_gdp(PAGESEL, (WritePage shl 2) or ReadPage);
End; {SelPage}

Procedure RMWon;
{Schaltet Read-modify-write-Modus an}
{Achtung!! Setzt das SCROLL-Register auf 0}
Begin
  GDPready;
  put_gdp(Scroll,128);
End; {RMWon}

Procedure RMWoff;
{Schaltet Read-modify-write-Modus aus}
{Achtung!! Setzt das SCROLL-Register auf 0}
Begin
  GDPready;
  put_gdp(Scroll,0);
End; {RMWoff}

Procedure Scrollen(Faktor : Byte);
{Beschreibt das SCROLL-Register}
{Achtung!! Schaltet read-modifiy-write ab}
Begin
  GDPready;
  VBready;
  put_gdp(SCROLL, Faktor);
End; {Scrollen}

Procedure GoXY(X,Y : Integer);
{Setzt das X- und Y-Register auf die uebergebenen Werte}
{Es wird keine Parameteruebepruefung durchgefuehrt!}
Begin
  GDPready;
  put_gdp(XLSB,X);
  put_gdp(YLSB,Y);
End; {GoXY}

Procedure GetXY(Var X,Y : Integer);
{Holt die derzeitige X,Y-Position vom EF9366}
Begin
  GDPready;
  X:= get_gdp(XLSB);
  Y:= get_gdp(YLSB);
End; {GetXY}

Procedure SelChar(Art : Byte);
{Selektiert eine Schriftart 0 = in X-Richtung normal
                            1 = in X-Richtung schraeg
                            2 = in Y-Richtung normal
                            3 = in Y-Richtung schraeg}
{Keine Parameterueberpruefung}
Begin;
  GDPready;
  Art:= Art shl 2;
  put_gdp(CTRL2, (get_gdp(CTRL2) and 3) or Art);
End; {SelChar}

Procedure InitGDP;
{Setzt alle Register auf 0, waehlt kleinste Schriftart mit normaler Darstellung}
{Loescht den Bildschirm der gewaehlten Seite}
Begin
  GDPready;
  put_gdp(CMD,7);
  SetColor(15,0);
  SelChar(0);
  SelPen;
  SelDown;
End; {InitGDP}

Procedure SelSize(X,Y : Byte);
{Setzt die Schriftgroesse in X,Y-Richtung}
{Uebergebene Parameter 1..16 = klein..gross}
Begin
  If X>15 then X:=0;
  If Y>15 then Y:=0;
  GDPready;
  put_gdp(CSIZE, (X shl 4) or Y);
End; {SelSize}

Procedure WriteGDP(Zeichen : Str255);
{Schreibt Zeichenfolgen in den EF9366}
Var K : Byte;
Begin
  For K:=1 to Length(Zeichen) do
    Begin
      GDPready;
      put_gdp(CMD, Ord(Zeichen[K]));
    End; {For}
End; {WriteGDP}

Procedure WriteUpcaseGDP(Zeichen : Str255);
{Schreibt Zeichenfolgen in den EF9366}
Var K : Byte;
Begin
  For K:=1 to Length(Zeichen) do
    Begin
      GDPready;
      put_gdp(CMD, Ord(Upcase(Zeichen[K])));
    End; {For}
End; {WriteUpcaseGDP}

Procedure WritelnGDP(Zeichen : Str255);
{Schreibt Zeichenfolgen in den EF9366 mit "CR"}
Var K : Byte;
    XPos,YPos : Integer;
Begin
  For K:=1 to Length(Zeichen) do
    Begin
      GDPready;
      put_gdp(CMD, Ord(Zeichen[K]));
    End; {For}
  GetXY(XPos,YPos);
  GoXY(0,YPos-10);
End; {WritelnGDP}

Procedure LVektor(NewX,NewY : Integer);
{Zeichnet einen Vektor von alter X,Y-Position zur  NewX,NewY-Position}
{Nur fuer grosse Vektoren z.B. ueber den ganzen Bildschirm}
{Grenzen: 0 <= NewX <= 511     0 <= NewY <= 255 (keine Ueberpruefung) }
Var X,Y    : Integer;
    X1,Y1,
    Befehl : Byte;

Procedure Zeichne(X,Y : Integer);
Begin
  GDPready;
  put_gdp(DELTAX,X);
  put_gdp(DELTAY,Y);
  put_gdp(CMD,Befehl);
End; {Zeichne}

Begin {LVektor}
  Befehl:= 17;
  GetXY(X,Y);
  X:= NewX - X;
  Y:= NewY - Y;
  If X<0 then
    Begin
      Befehl:= Befehl + 2;
      X:= Abs(X);
    End; {If}
  If Y<0 then
    Begin
      Befehl:= Befehl + 4;
      Y:= Abs(Y);
    End; {If}
  Case X of
    0..255    : Zeichne(X,Y);
    256..500  : Begin
                  X1:= X div 2;
                  Y1:= Y div 2;
                  Zeichne(X1,Y1);
                  X:= X - X1;
                  Y:= Y - Y1;
                  Zeichne(X,Y);
                End; {256..500}
    501..511  : Begin
                  X1:= X div 3;
                  Y1:= Y div 3;
                  Zeichne(X1,Y1);
                  X:= X - X1;
                  Y:= Y - Y1;
                  Zeichne(X1,Y1);
                  X:= X - 2*X1;
                  Y:= Y - 2* Y1;
                  Zeichne(X1,Y1);
                End; {256..500}
    End; {Case}
End; {LVektor}

Procedure XVektor(X : Integer);
{Zeichnet einen Vektor parallel zur X-Achse}
{-255 <= X <= -1 und 1 <= X <= 255, keine Parameterueberpruefung}
Begin
  GDPready;
  put_gdp(DELTAX,Abs(X));
  If X<0 then
    put_gdp(CMD,22)
  Else
    put_gdp(CMD,16);
End; {XVektor}

Procedure YVektor(Y : Integer);
{Zeichnet einen Vektor parallel zur Y-Achse}
{-255 <= Y <= -1 und 1 <= Y <= 255, keine Parameterueberpruefung}
Begin
  GDPready;
  put_gdp(DELTAY,Abs(Y));
  If Y<0 then
    put_gdp(CMD,20)
  Else
    put_gdp(CMD,18);
End; {YVektor}

Procedure WVektor(Winkel : Integer; XY : Byte);
{Zeichnet einen Vektor mit def. X,Y-Auslenkung und Winkel}
{Winkel: 0,45,90,135,180,225,270,315, XY: 0..255}
Var Befehl : Byte;
Begin
  Case Winkel of
      0 : Befehl:=  24;
     45 : Befehl:=  25;
     90 : Befehl:=  26;
    135 : Befehl:=  27;
    180 : Befehl:=  30;
    225 : Befehl:=  31;
    270 : Befehl:=  28;
    315 : Befehl:=  29;
  End; {Case}
  GDPready;
  put_gdp(DELTAY,0);
  put_gdp(DELTAX,XY);
  put_gdp(CMD,Befehl);
End; {WVektor}

Procedure SVektor(Winkel : Integer; X,Y : Byte);
{Zeichnet einen Kurzvektor X: 0..3, Y: 0..3}
{Winkel: 0,45,90,135,180,225,270,315}
Var Befehl : Byte;
Begin
  Case Winkel of
      0 : Befehl:=  128;
     45 : Befehl:=  129;
     90 : Befehl:=  130;
    135 : Befehl:=  131;
    180 : Befehl:=  134;
    225 : Befehl:=  135;
    270 : Befehl:=  132;
    315 : Befehl:=  133;
  End; {Case}
  Befehl:= Befehl or (X shl 5) or (Y shl 3);
  GDPready;
  put_gdp(CMD,Befehl);
End; {SVektor}

Procedure Koordi(KX,KY,VX,VY,SX,SY : Integer; MX,MY : Real; XStr,YStr : Str10);
{Zeichnet ein Koordinatensystem fuer Quadrant 1}
{KX,KY : Koordinatenursprung; VX,VY : Achsenlaenge}
{MX,MY : Maximalwerte der Achsenbezeichnung; SX,SY : Achsenteilung}
{XStr,YStr : Bezeichnung der Achsen}
Var K,Strich,
    XPos,YPos   : Integer;
    Scalewert,L : Real;
    Meldung     : Str255;
    StrLaenge   : Byte;
Begin
  GoXY(KX,KY);           {Koordinatenkreuz zeichnen}
  LVektor(KX+VX+10,KY);
  GoXY(KX,KY);
  LVektor(KX,KY+VY+10);
  Strich:= Round(VX * 0.01);
  L:= MX / SX;
  For K:=1 to SX do      {X-ASchse bezeichnen}
    Begin
      XPos:= Round(VX / SX * K);
      Scalewert:= L * K;
      XPos:= XPos + KX;
      YPos:= KY-Strich;
      GoXY(XPos,YPos);
      YVektor(Strich);
      Str(Scalewert:6:1,Meldung);
      While (Meldung[1]=' ') do delete(Meldung,1,1);
      StrLaenge:= Length(Meldung) * 8;
      GoXY(XPos - StrLaenge div 2,YPos-10);
      WriteGDP(Meldung);
    End; {For}
  GetXY(XPos,YPos);
  GoXY(XPos+4,YPos);
  WriteGDP(XStr);
  Strich:= Round(VY * 0.02);
  L:= MY / SY;
  For K:=1 to SY do      {Y-ASchse bezeichnen}
    Begin
      YPos:= Round(VY / SY * K);
      Scalewert:= L * K;
      YPos:= YPos + KY;
      XPos:= KX-Strich;
      GoXY(XPos,YPos);
      XVektor(Strich);
      Str(Scalewert:6:1,Meldung);
      While (Meldung[1]=' ') do delete(Meldung,1,1);
      StrLaenge:= Length(Meldung) * 8;
      GoXY(XPos - StrLaenge,YPos-4);
      WriteGDP(Meldung);
    End; {For}
  GetXY(XPos,YPos);
  GoXY(XPos-Length(YStr)*6,YPos+9);
  WriteGDP(YStr);
End; {Koordi}

Procedure NegYAchse(KX,KY,VY,SY : Integer; MY : Real);
{Zeichnet neg. Y-Achse (s. auch Koordi)}
Var Strich,
    StrLaenge   : Byte;
    K           : Integer;
    Meldung     : Str255;
    Scalewert,L : Real;
Begin
  GoXY(KX,KY-VY-10);
  LVektor(KX,KY);
  Strich:= Round(VY * 0.02);
  L:= MY / SY;
  For K:=1 to SY do      {Y-ASchse bezeichnen}
    Begin
      YPos:= Round(VY / SY * K);
      Scalewert:= -(L * K);
      YPos:= KY - YPos;
      XPos:= KX - Strich;
      GoXY(XPos,YPos);
      XVektor(Strich);
      Str(Scalewert:6:1,Meldung);
      While (Meldung[1]=' ') do delete(Meldung,1,1);
      StrLaenge:= Length(Meldung) * 8;
      GoXY(XPos - StrLaenge,YPos-4);
      WriteGDP(Meldung);
    End; {For}
End; {NegYAchse}

Procedure Punkt;
{Zeichnet einen Punkt}
{Achtung!! Als Vektorart muss 0 gewaehlt sein (SelType(0)}
Begin
  GDPready;
  put_gdp(CMD,128);
End; {Punkt}

Procedure KoorPunkt(KX,KY,VX,VY : Integer; SX,SY,MX,MY : Real);
{Zeichnet einen Punkt im Koordinatensystem im Quadranten 1}
{KX,KY : Koordinatenursprung; VX,VY : Achsenlaenge}
{MX,MY : Maximalwerte der Achsenbezeichnung; SX,SY : Punkt im System}
Var XPos,YPos  : Integer;
Begin
  XPos:= KX + Round(SX * VX / MX);
  YPos:= KY + Round(SY * VY / MY);
  GoXY(XPos,YPos);
  Punkt;
End; {KoorPunkt}

Function Pen; {Forward deklariert}
{Prueft ob als Schreibstift Pen gewaehlt ist}
Begin
  GDPready;
  Pen:= (get_gdp(CTRL1) and 2 = 2);
End; {Pen}

Function Eraser; {Forward deklariert}
{Prueft ob als Schreibstift Eraser gewaehlt ist}
Begin
  GDPready;
  Eraser:= (get_gdp(CTRL1) and 2 = 0);
End; {Eraser}

Function Up; {Forward deklariert}
{Prueft ob der Schreibstift oben ist}
Begin
  GDPready;
  Up:= (get_gdp(CTRL1) and 1 = 0);
End; {Up}

Function Down; {Forward deklariert}
{Prueft ob der Schreibstift unten ist}
Begin
  GDPready;
  Down:= (get_gdp(CTRL1) and 1 = 1);
End; {Down}

Function OutRange; {Forward deklariert}
{Prueft ob der Schreibstift ausserhalb des Bildschirmbereiches ist}
Begin;
  OutRange:= (get_gdp(STATUS) and $0800 = $0800);
End; {OutRange}

Function Msin(Winkel : Integer) : Real;
{Holt einen Sinus aus Tabelle Sinus}
Begin
  Msin:= Sinus[(Winkel mod 360) + 1] / 10000;
End; {Msin}

Function Mcos(Winkel : Integer) : Real;
{Holt einen Cosinus aus Tabelle Sinus}
Begin
  Mcos:= Sinus[((Winkel + 90) mod 360) + 1] / 10000;
End; {Mcos}

Function VideoRam : Byte;
{Liest die adressierte Speicherstelle des Video-Rams}
Begin
  GDPready;
  put_gdp(CMD,15);
  GDPready;
  VideoRam:= get_gdp(RAM);
End; {VideoRam}
