/*----------------------------------------------------------------------*/
/*									*/
/*	Copyright (c) 1992	ELZET 80 Mikrocomputer			*/
/*				All Rights Reserved			*/
/*									*/
/*----------------------------------------------------------------------*/
/*   GDP340 - Graphics Manager						*/
/*----------------------------------------------------------------------*/
/*   Header file for GM host side					*/
/*									*/
/*   Implemented GM functions						*/
/*									*/
/*   Notes:								*/
/*----------------------------------------------------------------------*/
/*   Revision history:							*/
/*   10.07.1992	Original Version Written		Reinhard Niebur	*/
/*   30.01.1993	New functions added			Reinhard Niebur	*/
/*----------------------------------------------------------------------*/

/* GDP340 GM function numbers */
#define	Bitblt			0
#define	Clear_Frame_Buffer	1
#define	Clear_Page		2
#define	Clear_Screen		3
#define	Cpw			4
#define	Cvxyl			5
#define	Decode_Rect		6
#define	Delete_Font		7
#define	Draw_Line		8
#define	Draw_Oval		9
#define	Draw_OvalArc		10
#define	Draw_PieArc		11
#define	Draw_Point		12
#define	Draw_PolyLine		13
#define	Draw_Rect		14
#define	Encode_Rect		15
#define	Field_Extract		16
#define	Field_Insert		17
#define	Fill_Convex		18
#define	Fill_Oval		19
#define	Fill_PieArc		20
#define	Fill_Polygon		21
#define	Fill_Rect		22
#define	Frame_Oval		23
#define	Frame_Rect		24
#define	Get_Colors		25
#define	Get_Config		26
#define	Get_Curs_State		27
#define	Get_Curs_XY		28
#define	Get_Env			29
#define	Get_FontInfo		30
#define	Get_ModeInfo		31
#define	Get_Nearest_Color	32
#define	Get_Offscreen_Memory	33
#define	Get_Palet		34
#define	Get_Palet_Entry		35
#define	Get_Pixel		36
#define	Get_PMask		37
#define	Get_PPop		38
#define	Get_TextAttr		39
#define	Get_Text_XY		40
#define	Get_Transp		41
#define	Get_Vector		42
#define	Get_Windowing		43
#define	Gsp2Gsp			44
#define	Get_Wksp		45
#define	In_Font			46
#define	Install_Font		47
#define	Init_Palet		48
#define	Init_Text		49
#define	Lmo			50
#define	Move_Pixel		51
#define	Page_Busy		52
#define	Page_Flip		53
#define	PatnFill_Convex		54
#define	PatnFill_Oval		55
#define	PatnFill_PieArc		56
#define	PatnFill_Polygon	57
#define	PatnFill_Rect		58
#define	PatnFrame_Oval		59
#define	PatnFrame_Rect		60
#define	PatnPen_Line		61
#define	PatnPen_OvalArc		62
#define	PatnPen_PieArc		63
#define	PatnPen_Point		64
#define	PatnPen_PolyLine	65
#define	Peek_BReg		66
#define	Pen_Line		67
#define	Pen_OvalArc		68
#define	Pen_PieArc		69
#define	Pen_Point		70
#define	Pen_PolyLine		71
#define	Poke_BReg		72
#define	Put_Pixel		73
#define	Rmo			74
#define	Seed_Fill		75
#define	Seed_PatnFill		76
#define	Select_Font		77
#define	Set_BColor		78
#define	Set_Clip_Rect		79
#define	Set_Colors		80
#define	Set_Config		81
#define	Set_Curs_Shape		82
#define	Set_Curs_State		83
#define	Set_Curs_XY		84
#define	Set_CursAttr		85
#define	Set_Draw_Origin		86
#define	Set_DstBm		87
#define	Set_FColor		88
#define	Set_Palet		89
#define	Set_Palet_Entry		90
#define	Set_Patn		91
#define	Set_PenSize		92
#define	Set_PMask		93
#define	Set_PPop		94
#define	Set_SrcBm		95
#define	Set_Text_XY		96
#define	Set_TextAttr		97
#define	Set_Vector		98
#define	Set_Windowing		99
#define	Set_Wksp		100
#define	Styled_Line		101
#define	Styled_Oval		102
#define	Styled_OvalArc		103
#define	Styled_PieArc		104
#define	Swap_Bm			105
#define	Text_Out		106
#define	Text_Outp		107
#define	Text_Width		108
#define	Transp_Off		109
#define	Transp_On		110
#define	Wait_Scan		111
#define	Zoom_Rect		112
#define	Gsp_CAlloc		113
#define	Gsp_Free		114
#define	Gsp_MAlloc		115
#define	Gsp_MInit		116
#define	Gsp_ReAlloc		117
#define Install_Hard_Font	118
#define Set_Hard_Patn		119
#define	Set_Hard_Curs_Shape	120
#define Delay			121

/* GDP340 GM function prototyping */
short	gm_init(void);
void	bitblt(short w, short h, short xs, short ys, short xd, short yd);
void	clear_frame_buffer(ulong color);
void	clear_page(ulong color);
void	clear_screen(ulong color);
short	cpw(short x, short y);
PTR	cvxyl(short x, short y);
short	decode_rect(short xleft, short ytop, PTR buf);
short	delete_font(short id);
void	draw_line(short x1, short y1, short x2, short y2);
void	draw_oval(short w, short h, short xleft, short ytop);
void	draw_ovalarc(short w, short h, short xleft, short ytop, short theta, short arc);
void	draw_piearc(short w, short h, short xleft, short ytop, short theta, short arc);
void	draw_point(short x, short y);
void	draw_polyline(short n, POINT2D *vert);
void	draw_rect(short w, short h, short xleft, short ytop);
ulong	encode_rect(short w, short h, short xleft, short ytop, PTR buf, ulong bufsize, ushort scheme);
ulong	field_extract(PTR gptr, ushort fs);
void	field_insert(PTR gptr, short fs, ulong val);
void	fill_convex(short n, POINT2D *vert);
void	fill_oval(short w, short h, short xleft, short ytop);
void	fill_piearc(short w, short h, short xleft, short ytop, short theta, short arc);
void	fill_polygon(short n, POINT2D *vert);
void	fill_rect(short w, short h, short xleft, short ytop);
void	frame_oval(short w, short h, short xleft, short ytop, short dx, short dy);
void	frame_rect(short w, short h, short xleft, short ytop, short dx, short dy);
void	get_colors(ulong *fcol, ulong *bcol);
void	get_config(CONFIG *config);
short	get_curs_state(void);
void	get_curs_xy(short *px, short *py);
void	get_env(ENVIRONMENT *env);
short	get_fontinfo(short id, FONTINFO *pfontinfo);
short	get_modeinfo(short index, MODEINFO *modeinfo);
ulong	get_nearest_color(uchar r, uchar g, uchar b, uchar i);
void	get_offscreen_memory(short num_blocks,OFFSCREEN_AREA *offscreen);
void	get_palet(short palet_size, PALET *palet);
short	get_palet_entry(long index, uchar *r, uchar *g, uchar *b, uchar *i);
ulong	get_pixel(short x, short y);
ulong	get_pmask(void);
ushort	get_ppop(void);
short	get_textattr(char *pcontrol, short count, short *val);
void	get_text_xy(short *x, short *y);
short	get_transp(void);
PTR	get_vector(short trapnum);
short	get_windowing(void);
void	gsp2gsp(PTR src, PTR dst, ulong length);
short	get_wksp(PTR *addr, ulong *pitch);
short	in_font(short start_code, short end_code);
short	install_font(PTR pfont);
void	init_palet(void);
void	init_text(void);
short	lmo(ulong n);
void	move_pixel(short xs, short ys, short xd, short yd);
short	page_busy(void);
void	page_flip(short disp, short draw);
void	patnfill_convex(short n, POINT2D *vert);
void	patnfill_oval(short w, short h, short xleft, short ytop);
void	patnfill_piearc(short w, short h, short xleft, short ytop, short theta, short arc);
void	patnfill_polygon(short n, POINT2D *vert);
void	patnfill_rect(short w, short h, short xleft, short ytop);
void	patnframe_oval(short w, short h, short xleft, short ytop, short dx, short dy);
void	patnframe_rect(short w, short h, short xleft, short ytop, short dx, short dy);
void	patnpen_line(short x1, short y1, short x2, short y2);
void	patnpen_ovalarc(short w, short h, short xleft, short ytop, short theta, short arc);
void	patnpen_piearc(short w, short h, short xleft, short ytop, short theta, short arc);
void	patnpen_point(short x, short y);
void	patnpen_polyline(short n, POINT2D *vert);
ulong	peek_breg(short breg);
void	pen_line(short x1, short y1, short x2, short y2);
void	pen_ovalarc(short w, short h, short xleft, short ytop, short theta, short arc);
void	pen_piearc(short w, short h, short xleft, short ytop, short theta, short arc);
void	pen_point(short x, short y);
void	pen_polyline(short n, POINT2D *vert);
void	poke_breg(short breg, ulong val);
void	put_pixel(ulong val, short x, short y);
short	rmo(ulong n);
void	seed_fill(short x, short y /*, char *buf, short maxbytes*/);
void	seed_patnfill(short x, short y /*, char *buf, short maxbytes*/);
short	select_font(short id);
void	set_bcolor(ulong color);
void	set_clip_rect(ushort w, ushort h, short xleft, short ytop);
void	set_colors(ulong fcolor, ulong bcolor);
short	set_config(short graphics_mode, short init_draw);
void	set_curs_shape(PTR shape);
void	set_curs_state(short enab);
void	set_curs_xy(short x, short y);
void	set_cursattr(ulong shape_c, ulong mask_c, ushort shape_a, ushort mask_a);
void	set_draw_origin(short x, short y);
void	set_dstbm(PTR baseaddr, short pitch, short xext, short yext, short psize);
void	set_fcolor(ulong color);
void	set_palet(long count, long index, PALET *palet);
short	set_palet_entry(long index, uchar r, uchar g, uchar b, uchar i);
void	set_patn(PATTERN *ppatn);
void	set_pensize(short x, short y);
void	set_pmask(ulong pmask);
void	set_ppop(short ppop);
void	set_srcbm(PTR baseaddr, short pitch, short xext, short yext, short psize);
void	set_text_xy(short x, short y);
short	set_textattr(char *pcontrol, short count, short *val);
PTR	set_vector(short trapnum, PTR gptr);
void	set_windowing(short mode);
void	set_wksp(PTR addr, ulong pitch);
void	styled_line(short x1, short y1, short x2, short y2, long style, short mode);
void	styled_oval(short w, short h, short xleft, short ytop, long style, short mode);
void	styled_ovalarc(short w, short h, short xleft, short ytop, short theta, short arc, long style, short mode);
void	styled_piearc(short w, short h, short xleft, short ytop, short theta, short arc, long style, short mode);
void	swap_bm(void);
short	text_out(short x, short y, char *s);
short	text_outp(char *s);
short	text_width(char *s);
void	transp_off(void);
void	transp_on(void);
void	wait_scan(short line);
void	zoom_rect(short ws, short hs, short xs, short ys, short wd, short hd, short xd, short yd, PTR rowbuf);
PTR	gsp_calloc(ulong num, ulong size);
void	gsp_free(PTR ptr);
PTR	gsp_malloc(ulong size);
void	gsp_minit(void);
PTR	gsp_realloc(PTR ptr, ulong size);
short	install_hard_font(short n);
void	set_hard_patn(short patn_nr);
void	set_hard_curs_shape(short id);
void	delay(short screens);
void	host2gsp(HPTR hptr, PTR gptr, ushort len, short swizzle);
void	gsp2host(PTR gptr, HPTR hptr, ushort len, short swizzle);
