/*----------------------------------------------------------------------*/
/*									*/
/*	Copyright (c) 1992	ELZET 80 Mikrocomputer			*/
/*				All Rights Reserved			*/
/*									*/
/*----------------------------------------------------------------------*/
/*   GDP340 - Graphics Manager						*/
/*----------------------------------------------------------------------*/
/*   Header file for GM host side					*/
/*									*/
/*   Host control register definitions					*/
/*									*/
/*   Notes: 								*/
/*----------------------------------------------------------------------*/
/*   Revision history:							*/
/*   10.07.1992	Original Version Written		Reinhard Niebur	*/
/*   27.02.1993 DOWNLOAD Flag removed, now in file GM.C	Reinhard Niebur	*/
/*----------------------------------------------------------------------*/

#define GDP_PROG_LOAD    0xFB800000l   /* Program load address in GSP RAM */
#define GDP_RES_VECT     0xFBFFFC00l   /* Vector table for all EPROM types */
#define GDP_PROG_START   0xFFC00000l   /* Program start address in GSP RAM */

/* Host control register bits */
#define	HLT	0x8000	/* Halt GSP */
#define	CF	0x4000	/* cache flush */
#define	LBL	0x2000	/* lower byte last */
#define	INCR	0x1000	/* Increment on read cycles */
#define	INCW	0x0800	/* Increment on write cycles */
#define	NMIMODE	0x0200	/* NMI mode (no stack usage) */
#define	NMI	0x0100	/* Non maskable int */
#define	INTOUT	0x0080	/* MSG Interrupt out */
#define	MSGOUT	0x0070	/* Message out mask */
#define	MSGOUT0	0x0000	/* Message out 0 */
#define	MSGOUT1	0x0010	/* Message out 1 */
#define	MSGOUT2	0x0020	/* Message out 2 */
#define	MSGOUT3	0x0030	/* Message out 3 */
#define	MSGOUT4	0x0040	/* Message out 4 */
#define	MSGOUT5	0x0050	/* Message out 5 */
#define	MSGOUT6	0x0060	/* Message out 6 */
#define	MSGOUT7	0x0070	/* Message out 7 */
#define	INTIN	0x0008	/* MSG Interrupt in */
#define	MSGIN	0x0007	/* Message in mask */
#define	MSGIN0	0x0000	/* Message in 0 */
#define	MSGIN1	0x0001	/* Message in 1 */
#define	MSGIN2	0x0002	/* Message in 2 */
#define	MSGIN3	0x0003	/* Message in 3 */
#define	MSGIN4	0x0004	/* Message in 4 */
#define	MSGIN5	0x0005	/* Message in 5 */
#define	MSGIN6	0x0006	/* Message in 6 */
#define	MSGIN7	0x0007	/* Message in 7 */

/* GSP NMI Vector Address */
#define NMI_LOW  0xFFFFFEE0l
#define NMI_HIGH 0xFFFFFEF0l

#define INTENB   0xC0000110l

/* Address of GDP Control Register */
#define CNTL_ADR 0x00300000l

