;-----------------------------------------------------------------------;
;									;
;	Copyright (c) 1992	ELZET 80 Mikrocomputer			;
;				All Rights Reserved			;
;									;
;-----------------------------------------------------------------------;
;   GDP340 - Graphics Manager						;
;-----------------------------------------------------------------------;
;   Header file for GM host side					;
;									;
;   Host control register definitions					;
;									;
;   Notes: 								;
;-----------------------------------------------------------------------;
;   Revision history:							;
;   19.03.1993	Original Version Written		Reinhard Niebur	;
;-----------------------------------------------------------------------;

GDP_PROG_LOAD     .equ	0FB800000h	; Program load address in GSP RAM
GDP_PROG_LOAD_LO  .equ	00000h
GDP_PROG_LOAD_HI  .equ	0FB80h
GDP_PROG_LOAD_LL  .equ	000h
GDP_PROG_LOAD_LH  .equ	000h
GDP_PROG_LOAD_HL  .equ	080h
GDP_PROG_LOAD_HH  .equ	0FBh
GDP_RES_VECT      .equ	0FBFFFC00h	; Vector table for all EPROM types
GDP_RES_VECT_LO   .equ	0FC00h
GDP_RES_VECT_HI   .equ	0FBFFh
GDP_RES_VECT_LL   .equ	000h
GDP_RES_VECT_LH   .equ	0FCh
GDP_RES_VECT_HL   .equ	0FFh
GDP_RES_VECT_HH   .equ	0FBh
GDP_PROG_START    .equ	0FFC00000h	; Program start address in GSP RAM
GDP_PROG_START_LO .equ	00000h
GDP_PROG_START_HI .equ	0FFC0h
GDP_PROG_START_LL .equ	000h
GDP_PROG_START_LH .equ	00h
GDP_PROG_START_HL .equ	0C0h
GDP_PROG_START_HH .equ	0FFh

; Host control register bits
HLT	.equ	08000h		; Halt GSP
CF	.equ	04000h		; cache flush
LBL	.equ	02000h		; lower byte last
INCR	.equ	01000h		; Increment on read cycles
INCW	.equ	00800h		; Increment on write cycles
NMIMODE	.equ	00200h		; NMI mode (no stack usage)
NMI	.equ	00100h		; Non maskable int
INTOUT	.equ	00080h		; MSG Interrupt out
MSGOUT	.equ	00070h		; Message out mask
MSGOUT0	.equ	00000h		; Message out 0
MSGOUT1	.equ	00010h		; Message out 1
MSGOUT2	.equ	00020h		; Message out 2
MSGOUT3	.equ	00030h		; Message out 3
MSGOUT4	.equ	00040h		; Message out 4
MSGOUT5	.equ	00050h		; Message out 5
MSGOUT6	.equ	00060h		; Message out 6
MSGOUT7	.equ	00070h		; Message out 7
INTIN	.equ	00008h		; MSG Interrupt in
MSGIN	.equ	00007h		; Message in mask
MSGIN0	.equ	00000h		; Message in 0
MSGIN1	.equ	00001h		; Message in 1
MSGIN2	.equ	00002h		; Message in 2
MSGIN3	.equ	00003h		; Message in 3
MSGIN4	.equ	00004h		; Message in 4
MSGIN5	.equ	00005h		; Message in 5
MSGIN6	.equ	00006h		; Message in 6
MSGIN7	.equ	00007h		; Message in 7

; GSP NMI Vector Address
NMI_LOW		.equ	0FFFFFEE0h
NMI_LOW_LO	.equ	0FEE0h
NMI_LOW_HI	.equ	0FFFFh
NMI_LOW_LL	.equ	0E0h
NMI_LOW_LH	.equ	0FEh
NMI_LOW_HL	.equ	0FFh
NMI_LOW_HH	.equ	0FFh
NMI_HIGH	.equ	0FFFFFEF0h
NMI_HIGH_LO	.equ	0FEF0h
NMI_HIGH_HI	.equ	0FFFFh
NMI_HIGH_LL	.equ	0F0h
NMI_HIGH_LH	.equ	0FEh
NMI_HIGH_HL	.equ	0FFh
NMI_HIGH_HH	.equ	0FFh

INTENB		.equ	0C0000110h
INTENB_LO	.equ	00110h
INTENB_HI	.equ	0C000h
INTENB_LL	.equ	010h
INTENB_LH	.equ	001h
INTENB_HL	.equ	000h
INTENB_HH	.equ	0C0h

; Address of GDP Control Register
CNTL_ADR	.equ	000300000h
CNTL_ADR_LO	.equ	00000h
CNTL_ADR_HI	.equ	00030h
CNTL_ADR_LL	.equ	000h
CNTL_ADR_LH	.equ	000h
CNTL_ADR_HL	.equ	030h
CNTL_ADR_HH	.equ	000h
