/*----------------------------------------------------------------------*/
/*									*/
/*	Copyright (c) 1992	ELZET 80 Mikrocomputer			*/
/*				All Rights Reserved			*/
/*									*/
/*----------------------------------------------------------------------*/
/*   GDP340 - Graphics Manager						*/
/*----------------------------------------------------------------------*/
/*   Function library test program					*/
/*									*/
/*									*/
/*   Notes:								*/
/*----------------------------------------------------------------------*/
/*   Revision history:							*/
/*   10.07.1992	Original Version Written		Reinhard Niebur	*/
/*   28.01.1993	Anpassung an Version 6.0		Reinhard Niebur	*/
/*   02.02.1993	Test aller Funktionen			Reinhard Niebur	*/
/*----------------------------------------------------------------------*/

#include "gmtest.h"

/* Demo global variables */

CONFIG cfg;
FONTINFO fontinfo;
PTR gsp_font;
short MODE, DMODE;
short hres,vres,x,y;
short patn,penw,penh;
char s[129];

/* Print error message and exit to DOS. */
void error(char *str)
{
    printf("[ Error: ");
    if (!*str)
        printf("Unexpected EOF");
    else
        printf("%s",str);
    printf(" ]\n");
    exit(1);
}

short install_fontfile(filename)
char *filename;
{
ushort buffer;
FILE  *stream;
FONT  *host_font;
int   return_value = FALSE;

    /* attempt to open font file for reading */
    if ((stream = fopen(filename,"r+b")) == NULL)
	return_value = FALSE;
    else
    {
	/* skip the first word of the file */
	if (!fread(&buffer, 2, 1, stream))
	    return_value = FALSE;
	else
	{
	    /* read the second word of the file */
	    if (!fread(&buffer, 2, 1, stream))
		return_value = FALSE;
	    else
	    {
		host_font = (FONT *) malloc(buffer);
		if (!host_font)
		    return_value = FALSE;
        	else
		{
		    fseek(stream, 0L, SEEK_SET);
		    if (!fread(host_font, 1, buffer, stream))
			return_value = FALSE;
		    else
		    {
			gsp_font = (PTR) gsp_malloc(buffer);
			if (!gsp_font)
			    return_value = FALSE;
			else
			{
			    host2gsp (host_font, gsp_font, buffer, 0);
			    return_value = install_font(gsp_font);
			}
		    }
		    free(host_font);
		}
	    }
	}
	fclose(stream);
    }
    return(return_value);
}

main(short argc,char *argv[])
{
short i,j,x1,y1;
short lp;
    if (!gm_init())
        error("No Response from GDP");

    MODE = 0;
    DMODE = 4;
    set_config(MODE,!0);
    get_config(&cfg);
    hres = cfg.mode.disp_hres;
    vres = cfg.mode.disp_vres;

    test01();
    test02();
    test03();
    test04();
    test05();
    test06();
    test07();
    test08();
    test09();
    test10();
    test11();
    test12();
    test13();
    test14();
    test15();
    test16();
    test17();
    test18();
    test19();
    test20();
    test21();
    test22();
    test23();
    test24();
    test25();
    test26();
    test27();
    test28();
    test29();
    test30();

}
